﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
'Custom View class
#Event: ExampleEvent (Value As Int)
#Event: Example2Event (Value As Int, Test as String)
#Event: Resize (Width As Double, Height As Double)
#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
#DesignerProperty: Key: Ratio, DisplayName: Resimen boy oranı, FieldType: Int, DefaultValue: 1
#DesignerProperty: Key: PictureIndex, DisplayName: Seçiçli resim sırası, FieldType: Int, DefaultValue: 0
#DesignerProperty: Key: Real_img_Height, DisplayName: Orjinal resim yüksekliği, FieldType: int, DefaultValue: 0
#DesignerProperty: Key: Real_img_Width, DisplayName: Orijinal resim genişliği, FieldType: int, DefaultValue: 0

#DesignerProperty: Key: TextcolorT, DisplayName: Label test color Aktive, FieldType: Color, DefaultValue: 0xFFFF0000, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: TextcolorF, DisplayName: Label text color pasive, FieldType: Color, DefaultValue: 0xFF0000FF, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: BackcolorT, DisplayName: Label b.color Aktive, FieldType: Color, DefaultValue: 0x80008000, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: BackcolorF, DisplayName: Label b.color Pasive, FieldType: Color, DefaultValue: 0x7EFF0000, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: BackcolorN, DisplayName: Label b.color Normal, FieldType: Color, DefaultValue: 0x7FFFFF00, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: Bordercolor, DisplayName: Label Border color, FieldType: Color, DefaultValue: 0x7E00008B, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: Back, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
Sub Class_Globals
	Type MyResim (Folder As String, Name As String, Picture As Image, Pic_Height As Int, Pic_Width As Int)
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private m As Map
	Private ScrollPaneX As ScrollPane
	Private imageViewX As ImageView
	Private Ratio As Double
	Private CMenu As ContextMenu
	Private Real_image_Height As Double
	Private Real_image_Width As Double
	Private PictureList As List
	Private SelectedIndex As Int
	Private Labels As List
	Private Label_Background_Color_T As Int
	Private Label_Background_Color_F As Int
	Private Label_Background_Color_N As Int
	Private Label_text_color_T As Int
	Private Label_text_color_F As Int
	Private Video As MediaPlayer
End Sub



'<code>
'	Dim m As Map
'	m.Initialize
'	m.Put("Zoom in 25%",0.25)
'	m.Put("Zoom in 50%",0.5)
'	m.Put("Fit 100%",1)
'	m.Put("Zoom out 125%",1.25)
'	m.Put("Zoom out 150%",1.5)
'	m.Put("Zoom out 200%",2)
'	Resim1.Initialize(Mform1,"Resim",m)
'</code>
Public Sub Initialize2 (Callback As Object, EventName As String,sagtus As Map )
	Log("Initialize2 ")
	mEventName = EventName
	mCallBack = Callback
	m=sagtus
	PictureList.Initialize
	PictureList.Clear
	Dim  a As B4XBitmap
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	Log("Initialize ")
	mEventName = EventName
	mCallBack = Callback
	PictureList.Initialize
	PictureList.Clear
	Labels.Initialize
End Sub
Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	Log("DesignerCreateView")
	Dim xui As XUI
	mBase = Base
	Ratio=Props.Get("Ratio")
	SelectedIndex=Props.Get("PictureIndex")
	Label_Background_Color_T=xui.PaintOrColorToColor(Props.Get("BackcolorT"))
	Label_Background_Color_F= xui.PaintOrColorToColor(Props.Get("BackcolorF"))
	Label_Background_Color_N= xui.PaintOrColorToColor(Props.Get("BackcolorN"))
	Label_text_color_T=xui.PaintOrColorToColor(Props.Get("TextcolorT"))
	Label_text_color_F=xui.PaintOrColorToColor(Props.Get("TextcolorF"))
	
	Labels.Initialize
	
	
	
	Dim mm As Map
	mm.Initialize
	mm.Clear
	mm.Put("Zoom in 25%",0.25)
	mm.Put("Zoom in 50%",0.5)
	mm.Put("Fit 100%",1)
	mm.Put("Zoom out 125%",1.25)
	mm.Put("Zoom out 150%",1.5)
	mm.Put("Zoom out 200%",2)
	
	ScrollPaneX.Initialize("ScrollPaneX")
	mBase.AddNode(ScrollPaneX,0,0,mBase.Width,mBase.Height)
	imageViewX.Initialize("imageViewX")
	Dim panex As Pane
	panex=ScrollPaneX.InnerNode
	panex.AddNode(imageViewX,0,0,mBase.Width,mBase.Height)
	'panex.AddNode(Video,0,0,-1,-1)
	Dim jo As JavaObject = imageViewX
	Dim e As Object = jo.CreateEventFromUI("javafx.event.EventHandler", "scroll", Null)
	jo.RunMethod("setOnScroll", Array(e))
	
	setZoomRate(mm)
End Sub

'Public Sub Vload(t As String)
'	Dim panex As Pane
'	panex=ScrollPaneX.InnerNode
'
'	Dim jo,mv As JavaObject
'	Log( File.GetUri(t,""))
'	Video.Initialize("Video",File.GetUri(t,""))
'	'mp.Initialize("mp",File.GetUri(File.DirAssets,"darling.mp4"))
'	mv=jo.InitializeNewInstance("javafx.scene.media.MediaView",Array As Object(Video))
'	'MainForm.RootPane.AddNode(mv,0,0,MainForm.WindowWidth,MainForm.Height)
'	panex.AddNode(mv,0,0,-1,-1)
'	'mv.RunMethod("setX",Array(100.0))
'	'mv.RunMethod("setY",Array(100.0))
'	mv.RunMethod("setFitWidth",Array(500.0))
'	mv.RunMethod("setFitHeight",Array(700.0))
'	Video.Play
'End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	Log("Base_Resize ")
	ScrollPaneX.PrefWidth=Width
	ScrollPaneX.PrefHeight=Height

	Redraw
	CallSub3(mCallBack,mEventName & "_Resize",Width,Height)
End Sub

Private Sub Redraw
	'If Ratio<1.1 And Ratio>0.9 Then Ratio=1
	
	
	If Video.IsInitialized Then
		Log("Ratio:"&Ratio)
		ScrollPaneX.InnerNode.PrefHeight=ScrollPaneX.PrefHeight*Ratio
		ScrollPaneX.InnerNode.PrefWidth=ScrollPaneX.PrefWidth*Ratio
		Real_image_Width=ScrollPaneX.InnerNode.PrefWidth
		Real_image_Height=ScrollPaneX.InnerNode.PrefHeight
		Log("innernodesize:"&Real_image_Width&":"&Real_image_Height)
		Video.Pause
		'Log("video Redraw"&Real_image_Width&"-"&Real_image_Height)
		Dim jo,mv As JavaObject
		mv=jo.InitializeNewInstance("javafx.scene.media.MediaView",Array As Object(Video))
		Log("V.size:"&(Real_image_Width)&" - "&(Real_image_Height))
		mv.RunMethod("setX",Array(0.0))
		mv.RunMethod("setY",Array(0.0))
		mv.RunMethod("setFitWidth",Array(Real_image_Width))
		mv.RunMethod("setFitHeight",Array(Real_image_Height))
		Video.Play
	Else
		ScrollPaneX.InnerNode.PrefHeight=Real_image_Height*Ratio
		ScrollPaneX.InnerNode.PrefWidth=Real_image_Width*Ratio
		imageViewX.PrefWidth=Real_image_Width*Ratio
		imageViewX.PrefHeight=Real_image_Height*Ratio
	End If
End Sub


Public Sub GetBase As Pane
	Return mBase
End Sub

Public Sub addPicture(Folder As String, Filename As String) As Boolean
	'imageViewX.MouseCursor=fx.Cursors.WAIT
	'ScrollPaneX.MouseCursor=fx.Cursors.WAIT
	If File.Exists(Folder,Filename) Then
			Dim x As MyResim
			x.Initialize
			x.Folder=Folder
			x.Name=Filename
			If x.Name.ToUpperCase.EndsWith(".PNG") Or x.Name.ToUpperCase.EndsWith(".JPG") Or x.Name.ToUpperCase.EndsWith(".BMP") Then
				Dim bmp As Image
				bmp.Initialize2(File.OpenInput(Folder,Filename))
				x.Pic_Width=bmp.Width
				x.Pic_Height=bmp.Height
				x.Picture=bmp
			Else
				x.Pic_Width=ScrollPaneX.PrefWidth
				x.Pic_Height=ScrollPaneX.PrefHeight
				x.Name=File.GetUri(Folder,Filename)
			End If
			PictureList.Add(x)
			RefreshLabel
			ScrollPaneX.MouseCursor=fx.Cursors.DEFAULT
			Return True
	Else if Folder.Trim="AssetsDir" Then
		Try
			Dim x As MyResim
			x.Initialize
			x.Folder=Folder
			x.Name=Filename
			If x.Name.ToUpperCase.EndsWith(".PNG") Or x.Name.ToUpperCase.EndsWith(".JPG") Or x.Name.ToUpperCase.EndsWith(".BMP") Then
				Dim bmp As Image
				bmp.Initialize2(File.OpenInput(Folder,Filename))
				x.Pic_Width=bmp.Width
				x.Pic_Height=bmp.Height
				x.Picture=bmp
				
			Else
				x.Pic_Width=ScrollPaneX.PrefWidth
				x.Pic_Height=ScrollPaneX.PrefHeight
				x.Name=File.GetUri(Folder,Filename)
			End If
			
			PictureList.Add(x)
			RefreshLabel
			ScrollPaneX.MouseCursor=fx.Cursors.DEFAULT
			Return True
		Catch
			Log("************RESIM*********************")
			Log(" resim dir assette doyası bulunamadı")
			Log("*********************************")
			RefreshLabel
			ScrollPaneX.MouseCursor=fx.Cursors.DEFAULT
			Return False
		End Try
	Else
			Log(File.DirAssets)
			Log("************RESIM*********************")
			Log(" resim doyası bulunamadı")
			Log("*********************************")
			RefreshLabel
			ScrollPaneX.MouseCursor=fx.Cursors.DEFAULT
			Return False
	End If
	
End Sub

Private Sub RefreshLabel
	
	If Labels.Size<> PictureList.Size Then
		For i=0 To Labels.Size-1
			Dim L As Label
			L=Labels.Get(i)
			L.RemoveNodeFromParent
		Next
	End If
	
	For i=0 To Labels.Size-1
		Dim L As Label=Labels.Get(i)
		L.RemoveNodeFromParent
	Next
	Labels.Clear
	
		For i=0 To PictureList.Size-1
			Dim L As Label
			L.Initialize("MYLBL")
			mBase.AddNode(L,10+i*40,10,30,30)
			L.Text=i+1
			L.Tag=i
			L.Alignment="CENTER"
			L.TextColor=fx.Colors.From32Bit(Label_text_color_F)
			Dim x As MyResim=PictureList.Get(i)
			L.TooltipText=x.Name
			If x.Name.ToUpperCase.EndsWith(".PNG") Or x.Name.ToUpperCase.EndsWith(".JPG") Or x.Name.ToUpperCase.EndsWith(".BMP") Then 
				CSSUtils.SetBorder(L,0,fx.Colors.From32Bit(Label_Background_Color_N),15)
			Else
				CSSUtils.SetBorder(L,0,fx.Colors.From32Bit(Label_Background_Color_N),0)
			End If
			
			CSSUtils.SetBackgroundColor(L,fx.Colors.From32Bit(Label_Background_Color_N))
			L.MouseCursor=fx.Cursors.HAND
			
			Labels.Add(L)	
		Next
	
	Return
	
	
End Sub


Private Sub MYLBL_MouseClicked (EventData As MouseEvent)
	Log(PictureList.Size&"--"&Labels.Size)
	For i=0 To PictureList.Size-1
		Dim L As Label=Labels.Get(i)
		L.TextColor=fx.Colors.From32Bit(Label_text_color_F)
		CSSUtils.SetBackgroundColor(L,fx.Colors.From32Bit(Label_Background_Color_N))
	Next 
		
	If EventData.ClickCount>1 Then
		Dim lbl As Label
		lbl= Sender
		PictureSelect(lbl.Tag)
		lbl.TextColor=fx.Colors.From32Bit(Label_text_color_T)
		CSSUtils.SetBackgroundColor(lbl,fx.Colors.From32Bit(Label_Background_Color_T))
	End If
End Sub


Private Sub Refresh
	
	Redraw
End Sub


Public Sub SetPictureIndex(index As Int)
	PictureSelect(index)
End Sub

Public Sub GetPictureIndex As Int
	Return SelectedIndex
End Sub

Public  Sub PicturesClear
	PictureList.Clear
	RefreshLabel
End Sub

Private Sub PictureSelect(index As Int)
	If index>=PictureList.Size Then
		Log("************RESIM*********************")
		Log(" seçilen resim kodu, mevcut listeden fazla")
		Log("*********************************")
		Return
	End If
	Dim x As MyResim
	x.Initialize
	x=PictureList.Get(index)
	
	If x.Picture.IsInitialized Then
		Real_image_Height=x.Pic_Height
		Real_image_Width=x.Pic_Width
		Ratio=1
		imageViewX.SetImage(x.Picture)
		imageViewX.Visible=True
	Else
		Real_image_Height=ScrollPaneX.PrefHeight
		Real_image_Width=ScrollPaneX.PrefWidth
		Ratio=1
		Video.Initialize("Video",File.GetUri(x.Folder,""))
		Dim jo,mv As JavaObject
		mv=jo.InitializeNewInstance("javafx.scene.media.MediaView",Array As Object(Video))
		Dim panex As Pane
		panex=ScrollPaneX.InnerNode
		panex.AddNode(mv,0,0,-1,-1)
		'panex.AddNode(mv,0,0,Real_image_Width,Real_image_Height)
		'imageViewX.Visible=False
	End If
	SelectedIndex=index
	
	Redraw
End Sub

Public Sub Load(dir As String, Filename As String)
	Dim bmp As Image
	bmp.Initialize2(File.OpenInput(dir,Filename))
	Real_image_Height=bmp.Height
	Real_image_Width=bmp.Width
	Ratio=1
	ScrollPaneX.InnerNode.PrefHeight=Real_image_Height
	ScrollPaneX.InnerNode.PrefWidth=Real_image_Width
	imageViewX.PrefHeight=Real_image_Height
	imageViewX.PrefWidth=Real_image_Width
	imageViewX.SetImage(bmp)
	ScrollPaneX.Pannable=True
End Sub

'<code>
'	Dim m As Map
'	m.Initialize
'	m.Put("Zoom in 25%",0.25)
'	m.Put("Zoom in 50%",0.5)
'	m.Put("Fit 100%",1)
'	m.Put("Zoom out 125%",1.25)
'	m.Put("Zoom out 150%",1.5)
'	m.Put("Zoom out 200%",2)
'   Resim1.setZoomRate(m)
'</code>
Public Sub setZoomRate(maplist As Map) As Boolean
	m.Initialize
	m.Clear
	m.Put("[Fit in page]",0.009999)
	m.Put("[Zoom +20%]",0.0099)
	m.Put("[Zoom -20%]",-0.0099)
	For i = 0 To maplist.Size - 1
		m.put(maplist.GetKeyAt(i),maplist.GetValueAt(i))
	Next
	CMenu.Initialize("CM")
	For i = 0 To m.Size - 1
		Dim MItem As MenuItem
		MItem.Initialize(m.GetKeyAt(i),"CM")
		CMenu.MenuItems.Add(MItem)
		If IsNumber(m.GetValueAt(i))=False Then
			Log("************RESIM*********************")
			Log("Zoom oranı sayı olarak tanımlanmamış")
			Log("Lütfen tekrar yükleme yapınız")
			Log("*********************************")
			Return False
		End If
	Next
	ScrollPaneX.ContextMenu=CMenu
	Return True
End Sub
Public Sub getZoomRate As Map
	Return m
End Sub

'<code>
' Resim1.setColor(fx.Colors.Green)
'</code>
Public Sub setColor(bcolor As Object)
	CSSUtils.SetBackgroundColor(ScrollPaneX,bcolor)
	CSSUtils.SetBackgroundColor(imageViewX,bcolor)
End Sub

Private Sub CM_Action
	Dim MItem As MenuItem = Sender
	If m.GetDefault(MItem.Text,1)=0.0099 Then
		Ratio = Ratio*1.2
	else if m.GetDefault(MItem.Text,1)=0-0.0099 Then
		Ratio = Ratio*0.8
	else if m.GetDefault(MItem.Text,1)=0.009999 Then
		If Real_image_Height/ScrollPaneX.PrefHeight>Real_image_Width/ScrollPaneX.PrefWidth Then
			Ratio = ScrollPaneX.PrefHeight/Real_image_Height
		Else
			Ratio = ScrollPaneX.PrefWidth/Real_image_Width
		End If
	Else
		Ratio = m.GetDefault(MItem.Text,1)
	End If
	If Ratio<=0.05 Then  Ratio=0.05
	If Ratio>=5 Then Ratio=5
	Redraw
End Sub

Public Sub setTag(Tag As String)
	mBase.Tag = Tag
End Sub
Public Sub getTag As String
	Return mBase.Tag
End Sub

Public Sub setVisible(Visible As Boolean)
	mBase.Visible = Visible
End Sub
Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

Public Sub setLabel_Background_Color_T(color As Int)
	Label_Background_Color_T=color
	RefreshLabel
End Sub
Public Sub getLabel_Background_Color_T As Int
	Return Label_Background_Color_T
End Sub

Public Sub setLabel_Background_Color_N(color As Int)
	Label_Background_Color_N=color
	RefreshLabel
End Sub
Public Sub getLabel_Background_Color_N As Int
	Return Label_Background_Color_N
End Sub
Public Sub setLabel_Background_Color_F(color As Int)
	Label_Background_Color_F=color
	RefreshLabel
End Sub
Public Sub getLabel_Background_Color_F As Int
	Return Label_Background_Color_F
End Sub
Public Sub setEnabled(Enabled As Boolean)
	mBase.Enabled = Enabled
	For Each v As Node In mBase.GetAllViewsRecursive
		v.Enabled = Enabled
	Next
End Sub
Public Sub getEnabled As Boolean
	Return mBase.Enabled
End Sub

